"use strict";var defaultInstanceSettings={update:null,begin:null,loopBegin:null,changeBegin:null,change:null,changeComplete:null,loopComplete:null,complete:null,loop:1,direction:"normal",autoplay:!0,timelineOffset:0},defaultTweenSettings={duration:1e3,delay:0,endDelay:0,easing:"easeOutElastic(1, .5)",round:0},validTransforms=["translateX","translateY","translateZ","rotate","rotateX","rotateY","rotateZ","scale","scaleX","scaleY","scaleZ","skew","skewX","skewY","perspective"],cache={CSS:{},springs:{}};function minMax(val,min,max){return Math.min(Math.max(val,min),max)}function stringContains(str,text){return-1<str.indexOf(text)}function applyArguments(func,args){return func.apply(null,args)}var is={arr:function(a){return Array.isArray(a)},obj:function(a){return stringContains(Object.prototype.toString.call(a),"Object")},pth:function(a){return is.obj(a)&&a.hasOwnProperty("totalLength")},svg:function(a){return a instanceof SVGElement},inp:function(a){return a instanceof HTMLInputElement},dom:function(a){return a.nodeType||is.svg(a)},str:function(a){return"string"===typeof a},fnc:function(a){return"function"===typeof a},und:function(a){return"undefined"===typeof a},hex:function(a){return /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(a)},rgb:function(a){return /^rgb/.test(a)},hsl:function(a){return /^hsl/.test(a)},col:function(a){return is.hex(a)||is.rgb(a)||is.hsl(a)},key:function(a){return!defaultInstanceSettings.hasOwnProperty(a)&&!defaultTweenSettings.hasOwnProperty(a)&&"targets"!==a&&"keyframes"!==a}};function parseEasingParameters(string){var match=/\(([^)]+)\)/.exec(string);return match?match[1].split(",").map(function(p){return parseFloat(p)}):[]}function spring(string,duration){var _Mathsqrt=Math.sqrt,params=parseEasingParameters(string),mass=minMax(is.und(params[0])?1:params[0],.1,100),stiffness=minMax(is.und(params[1])?100:params[1],.1,100),damping=minMax(is.und(params[2])?10:params[2],.1,100),velocity=minMax(is.und(params[3])?0:params[3],.1,100),w0=_Mathsqrt(stiffness/mass),zeta=damping/(2*_Mathsqrt(stiffness*mass)),wd=1>zeta?w0*_Mathsqrt(1-zeta*zeta):0,a=1,b=1>zeta?(zeta*w0+-velocity)/wd:-velocity+w0;function solver(t){var _Mathexp=Math.exp,progress=duration?duration*t/1e3:t;if(1>zeta){progress=_Mathexp(-progress*zeta*w0)*(a*Math.cos(wd*progress)+b*Math.sin(wd*progress))}else{progress=(a+b*progress)*_Mathexp(-progress*w0)}if(0===t||1===t){return t}return 1-progress}function getDuration(){var cached=cache.springs[string];if(cached){return cached}var frame=1/6,elapsed=0,rest=0;while(!0){elapsed+=frame;if(1===solver(elapsed)){rest++;if(16<=rest){break}}else{rest=0}}var duration=1e3*(elapsed*frame);cache.springs[string]=duration;return duration}return duration?solver:getDuration}function elastic(amplitude,period){var _MathPI=Math.PI;if(void 0===amplitude)amplitude=1;if(void 0===period)period=.5;var a=minMax(amplitude,1,10),p=minMax(period,.1,2);return function(t){return 0===t||1===t?t:-a*Math.pow(2,10*(t-1))*Math.sin((t-1-p/(2*_MathPI)*Math.asin(1/a))*(2*_MathPI)/p)}}function steps(steps){if(void 0===steps)steps=10;return function(t){return Math.round(t*steps)*(1/steps)}}var bezier=function(){var kSplineTableSize=11,kSampleStepSize=1/(kSplineTableSize-1);function A(aA1,aA2){return 1-3*aA2+3*aA1}function B(aA1,aA2){return 3*aA2-6*aA1}function C(aA1){return 3*aA1}function calcBezier(aT,aA1,aA2){return((A(aA1,aA2)*aT+B(aA1,aA2))*aT+C(aA1))*aT}function getSlope(aT,aA1,aA2){return 3*A(aA1,aA2)*aT*aT+2*B(aA1,aA2)*aT+C(aA1)}function binarySubdivide(aX,aA,aB,mX1,mX2){var currentX,currentT,i=0;do{currentT=aA+(aB-aA)/2;currentX=calcBezier(currentT,mX1,mX2)-aX;if(0<currentX){aB=currentT}else{aA=currentT}}while(1e-7<Math.abs(currentX)&&10>++i);return currentT}function newtonRaphsonIterate(aX,aGuessT,mX1,mX2){for(var i=0,currentSlope;4>i;++i){currentSlope=getSlope(aGuessT,mX1,mX2);if(0===currentSlope){return aGuessT}var currentX=calcBezier(aGuessT,mX1,mX2)-aX;aGuessT-=currentX/currentSlope}return aGuessT}function bezier(mX1,mY1,mX2,mY2){if(!(0<=mX1&&1>=mX1&&0<=mX2&&1>=mX2)){return}var sampleValues=new Float32Array(kSplineTableSize);if(mX1!==mY1||mX2!==mY2){for(var i=0;i<kSplineTableSize;++i){sampleValues[i]=calcBezier(i*kSampleStepSize,mX1,mX2)}}function getTForX(aX){var intervalStart=0,currentSample=1,lastSample=kSplineTableSize-1;for(;currentSample!==lastSample&&sampleValues[currentSample]<=aX;++currentSample){intervalStart+=kSampleStepSize}--currentSample;var dist=(aX-sampleValues[currentSample])/(sampleValues[currentSample+1]-sampleValues[currentSample]),guessForT=intervalStart+dist*kSampleStepSize,initialSlope=getSlope(guessForT,mX1,mX2);if(.001<=initialSlope){return newtonRaphsonIterate(aX,guessForT,mX1,mX2)}else if(0===initialSlope){return guessForT}else{return binarySubdivide(aX,intervalStart,intervalStart+kSampleStepSize,mX1,mX2)}}return function(x){if(mX1===mY1&&mX2===mY2){return x}if(0===x||1===x){return x}return calcBezier(getTForX(x),mY1,mY2)}}return bezier}(),penner=function(){var names=["Quad","Cubic","Quart","Quint","Sine","Expo","Circ","Back","Elastic"],curves={In:[[.55,.085,.68,.53],[.55,.055,.675,.19],[.895,.03,.685,.22],[.755,.05,.855,.06],[.47,0,.745,.715],[.95,.05,.795,.035],[.6,.04,.98,.335],[.6,-.28,.735,.045],elastic],Out:[[.25,.46,.45,.94],[.215,.61,.355,1],[.165,.84,.44,1],[.23,1,.32,1],[.39,.575,.565,1],[.19,1,.22,1],[.075,.82,.165,1],[.175,.885,.32,1.275],function(a,p){return function(t){return 1-elastic(a,p)(1-t)}}],InOut:[[.455,.03,.515,.955],[.645,.045,.355,1],[.77,0,.175,1],[.86,0,.07,1],[.445,.05,.55,.95],[1,0,0,1],[.785,.135,.15,.86],[.68,-.55,.265,1.55],function(a,p){return function(t){return .5>t?elastic(a,p)(2*t)/2:1-elastic(a,p)(-2*t+2)/2}}]},eases={linear:[.25,.25,.75,.75]},loop=function(coords){curves[coords].forEach(function(ease,i){eases["ease"+coords+names[i]]=ease})};for(var coords in curves)loop(coords);return eases}();function parseEasings(easing,duration){if(is.fnc(easing)){return easing}var name=easing.split("(")[0],ease=penner[name],args=parseEasingParameters(easing);switch(name){case"spring":return spring(easing,duration);case"cubicBezier":return applyArguments(bezier,args);case"steps":return applyArguments(steps,args);default:return is.fnc(ease)?applyArguments(ease,args):applyArguments(bezier,ease);}}function selectString(str){try{var nodes=document.querySelectorAll(str);return nodes}catch(e){return}}function filterArray(arr,callback){for(var len=arr.length,thisArg=2<=arguments.length?arguments[1]:void 0,result=[],i=0;i<len;i++){if(i in arr){var val=arr[i];if(callback.call(thisArg,val,i,arr)){result.push(val)}}}return result}function flattenArray(arr){return arr.reduce(function(a,b){return a.concat(is.arr(b)?flattenArray(b):b)},[])}function toArray(o){if(is.arr(o)){return o}if(is.str(o)){o=selectString(o)||o}if(o instanceof NodeList||o instanceof HTMLCollection){return[].slice.call(o)}return[o]}function arrayContains(arr,val){return arr.some(function(a){return a===val})}function cloneObject(o){var clone={};for(var p in o){clone[p]=o[p]}return clone}function replaceObjectProps(o1,o2){var o=cloneObject(o1);for(var p in o1){o[p]=o2.hasOwnProperty(p)?o2[p]:o1[p]}return o}function mergeObjects(o1,o2){var o=cloneObject(o1);for(var p in o2){o[p]=is.und(o1[p])?o2[p]:o1[p]}return o}function rgbToRgba(rgbValue){var rgb=/rgb\((\d+,\s*[\d]+,\s*[\d]+)\)/g.exec(rgbValue);return rgb?"rgba("+rgb[1]+",1)":rgbValue}function hexToRgba(hexValue){var rgx=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,hex=hexValue.replace(rgx,function(m,r,g,b){return r+r+g+g+b+b}),rgb=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex),r=parseInt(rgb[1],16),g=parseInt(rgb[2],16),b=parseInt(rgb[3],16);return"rgba("+r+","+g+","+b+",1)"}function hslToRgba(hslValue){var hsl=/hsl\((\d+),\s*([\d.]+)%,\s*([\d.]+)%\)/g.exec(hslValue)||/hsla\((\d+),\s*([\d.]+)%,\s*([\d.]+)%,\s*([\d.]+)\)/g.exec(hslValue),h=parseInt(hsl[1],10)/360,s=parseInt(hsl[2],10)/100,l=parseInt(hsl[3],10)/100,a=hsl[4]||1;function hue2rgb(p,q,t){if(0>t){t+=1}if(1<t){t-=1}if(t<1/6){return p+6*(q-p)*t}if(t<1/2){return q}if(t<2/3){return p+6*((q-p)*(2/3-t))}return p}var r,g,b;if(0==s){r=g=b=l}else{var q=.5>l?l*(1+s):l+s-l*s,p=2*l-q;r=hue2rgb(p,q,h+1/3);g=hue2rgb(p,q,h);b=hue2rgb(p,q,h-1/3)}return"rgba("+255*r+","+255*g+","+255*b+","+a+")"}function colorToRgb(val){if(is.rgb(val)){return rgbToRgba(val)}if(is.hex(val)){return hexToRgba(val)}if(is.hsl(val)){return hslToRgba(val)}}function getUnit(val){var split=/([\+\-]?[0-9#\.]+)(%|px|pt|em|rem|in|cm|mm|ex|ch|pc|vw|vh|vmin|vmax|deg|rad|turn)?$/.exec(val);if(split){return split[2]}}function getTransformUnit(propName){if(stringContains(propName,"translate")||"perspective"===propName){return"px"}if(stringContains(propName,"rotate")||stringContains(propName,"skew")){return"deg"}}function getFunctionValue(val,animatable){if(!is.fnc(val)){return val}return val(animatable.target,animatable.id,animatable.total)}function getAttribute(el,prop){return el.getAttribute(prop)}function convertPxToUnit(el,value,unit){var valueUnit=getUnit(value);if(arrayContains([unit,"deg","rad","turn"],valueUnit)){return value}var cached=cache.CSS[value+unit];if(!is.und(cached)){return cached}var baseline=100,tempEl=document.createElement(el.tagName),parentEl=el.parentNode&&el.parentNode!==document?el.parentNode:document.body;parentEl.appendChild(tempEl);tempEl.style.position="absolute";tempEl.style.width=baseline+unit;var factor=baseline/tempEl.offsetWidth;parentEl.removeChild(tempEl);var convertedUnit=factor*parseFloat(value);cache.CSS[value+unit]=convertedUnit;return convertedUnit}function getCSSValue(el,prop,unit){if(prop in el.style){var uppercasePropName=prop.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase(),value=el.style[prop]||getComputedStyle(el).getPropertyValue(uppercasePropName)||"0";return unit?convertPxToUnit(el,value,unit):value}}function getAnimationType(el,prop){if(is.dom(el)&&!is.inp(el)&&(getAttribute(el,prop)||is.svg(el)&&el[prop])){return"attribute"}if(is.dom(el)&&arrayContains(validTransforms,prop)){return"transform"}if(is.dom(el)&&"transform"!==prop&&getCSSValue(el,prop)){return"css"}if(null!=el[prop]){return"object"}}function getElementTransforms(el){if(!is.dom(el)){return}var str=el.style.transform||"",reg=/(\w+)\(([^)]*)\)/g,transforms=new Map,m;while(m=reg.exec(str)){transforms.set(m[1],m[2])}return transforms}function getTransformValue(el,propName,animatable,unit){var defaultVal=stringContains(propName,"scale")?1:0+getTransformUnit(propName),value=getElementTransforms(el).get(propName)||defaultVal;if(animatable){animatable.transforms.list.set(propName,value);animatable.transforms.last=propName}return unit?convertPxToUnit(el,value,unit):value}function getOriginalTargetValue(target,propName,unit,animatable){switch(getAnimationType(target,propName)){case"transform":return getTransformValue(target,propName,animatable,unit);case"css":return getCSSValue(target,propName,unit);case"attribute":return getAttribute(target,propName);default:return target[propName]||0;}}function getRelativeValue(to,from){var operator=/^(\*=|\+=|-=)/.exec(to);if(!operator){return to}var u=getUnit(to)||0,x=parseFloat(from),y=parseFloat(to.replace(operator[0],""));switch(operator[0][0]){case"+":return x+y+u;case"-":return x-y+u;case"*":return x*y+u;}}function validateValue(val,unit){if(is.col(val)){return colorToRgb(val)}var originalUnit=getUnit(val),unitLess=originalUnit?val.substr(0,val.length-originalUnit.length):val;return unit&&!/\s/g.test(val)?unitLess+unit:unitLess}function getDistance(p1,p2){var _Mathpow=Math.pow;return Math.sqrt(_Mathpow(p2.x-p1.x,2)+_Mathpow(p2.y-p1.y,2))}function getCircleLength(el){return 2*Math.PI*getAttribute(el,"r")}function getRectLength(el){return 2*getAttribute(el,"width")+2*getAttribute(el,"height")}function getLineLength(el){return getDistance({x:getAttribute(el,"x1"),y:getAttribute(el,"y1")},{x:getAttribute(el,"x2"),y:getAttribute(el,"y2")})}function getPolylineLength(el){for(var points=el.points,totalLength=0,previousPos,i=0,currentPos;i<points.numberOfItems;i++){currentPos=points.getItem(i);if(0<i){totalLength+=getDistance(previousPos,currentPos)}previousPos=currentPos}return totalLength}function getPolygonLength(el){var points=el.points;return getPolylineLength(el)+getDistance(points.getItem(points.numberOfItems-1),points.getItem(0))}function getTotalLength(el){if(el.getTotalLength){return el.getTotalLength()}switch(el.tagName.toLowerCase()){case"circle":return getCircleLength(el);case"rect":return getRectLength(el);case"line":return getLineLength(el);case"polyline":return getPolylineLength(el);case"polygon":return getPolygonLength(el);}}function setDashoffset(el){var pathLength=getTotalLength(el);el.setAttribute("stroke-dasharray",pathLength);return pathLength}function getParentSvgEl(el){var parentEl=el.parentNode;while(is.svg(parentEl)){parentEl=parentEl.parentNode;if(!is.svg(parentEl.parentNode)){break}}return parentEl}function getParentSvg(pathEl,svgData){var svg=svgData||{},parentSvgEl=svg.el||getParentSvgEl(pathEl),rect=parentSvgEl.getBoundingClientRect(),viewBoxAttr=getAttribute(parentSvgEl,"viewBox"),width=rect.width,height=rect.height,viewBox=svg.viewBox||(viewBoxAttr?viewBoxAttr.split(" "):[0,0,width,height]);return{el:parentSvgEl,viewBox:viewBox,x:viewBox[0]/1,y:viewBox[1]/1,w:width/viewBox[2],h:height/viewBox[3]}}function getPath(path,percent){var pathEl=is.str(path)?selectString(path)[0]:path,p=percent||100;return function(property){return{property:property,el:pathEl,svg:getParentSvg(pathEl),totalLength:getTotalLength(pathEl)*(p/100)}}}function getPathProgress(path,progress){function point(offset){if(void 0===offset)offset=0;var l=1<=progress+offset?progress+offset:0;return path.el.getPointAtLength(l)}var svg=getParentSvg(path.el,path.svg),p=point(),p0=point(-1),p1=point(+1);switch(path.property){case"x":return(p.x-svg.x)*svg.w;case"y":return(p.y-svg.y)*svg.h;case"angle":return 180*Math.atan2(p1.y-p0.y,p1.x-p0.x)/Math.PI;}}function decomposeValue(val,unit){var rgx=/-?\d*\.?\d+/g,value=validateValue(is.pth(val)?val.totalLength:val,unit)+"";return{original:value,numbers:value.match(rgx)?value.match(rgx).map(Number):[0],strings:is.str(val)||unit?value.split(rgx):[]}}function parseTargets(targets){var targetsArray=targets?flattenArray(is.arr(targets)?targets.map(toArray):toArray(targets)):[];return filterArray(targetsArray,function(item,pos,self){return self.indexOf(item)===pos})}function getAnimatables(targets){var parsed=parseTargets(targets);return parsed.map(function(t,i){return{target:t,id:i,total:parsed.length,transforms:{list:getElementTransforms(t)}}})}function normalizePropertyTweens(prop,tweenSettings){var settings=cloneObject(tweenSettings);if(/^spring/.test(settings.easing)){settings.duration=spring(settings.easing)}if(is.arr(prop)){var l=prop.length,isFromTo=2===l&&!is.obj(prop[0]);if(!isFromTo){if(!is.fnc(tweenSettings.duration)){settings.duration=tweenSettings.duration/l}}else{prop={value:prop}}}var propArray=is.arr(prop)?prop:[prop];return propArray.map(function(v,i){var obj=is.obj(v)&&!is.pth(v)?v:{value:v};if(is.und(obj.delay)){obj.delay=!i?tweenSettings.delay:0}if(is.und(obj.endDelay)){obj.endDelay=i===propArray.length-1?tweenSettings.endDelay:0}return obj}).map(function(k){return mergeObjects(k,settings)})}function flattenKeyframes(keyframes){for(var propertyNames=filterArray(flattenArray(keyframes.map(function(key){return Object.keys(key)})),function(p){return is.key(p)}).reduce(function(a,b){if(0>a.indexOf(b)){a.push(b)}return a},[]),properties={},loop=function(i){var propName=propertyNames[i];properties[propName]=keyframes.map(function(key){var newKey={};for(var p in key){if(is.key(p)){if(p==propName){newKey.value=key[p]}}else{newKey[p]=key[p]}}return newKey})},i=0;i<propertyNames.length;i++)loop(i);return properties}function getProperties(tweenSettings,params){var properties=[],keyframes=params.keyframes;if(keyframes){params=mergeObjects(flattenKeyframes(keyframes),params)}for(var p in params){if(is.key(p)){properties.push({name:p,tweens:normalizePropertyTweens(params[p],tweenSettings)})}}return properties}function normalizeTweenValues(tween,animatable){var t={};for(var p in tween){var value=getFunctionValue(tween[p],animatable);if(is.arr(value)){value=value.map(function(v){return getFunctionValue(v,animatable)});if(1===value.length){value=value[0]}}t[p]=value}t.duration=parseFloat(t.duration);t.delay=parseFloat(t.delay);return t}function normalizeTweens(prop,animatable){var previousTween;return prop.tweens.map(function(t){var tween=normalizeTweenValues(t,animatable),tweenValue=tween.value,to=is.arr(tweenValue)?tweenValue[1]:tweenValue,toUnit=getUnit(to),originalValue=getOriginalTargetValue(animatable.target,prop.name,toUnit,animatable),previousValue=previousTween?previousTween.to.original:originalValue,from=is.arr(tweenValue)?tweenValue[0]:previousValue,fromUnit=getUnit(from)||getUnit(originalValue),unit=toUnit||fromUnit;if(is.und(to)){to=previousValue}tween.from=decomposeValue(from,unit);tween.to=decomposeValue(getRelativeValue(to,from),unit);tween.start=previousTween?previousTween.end:0;tween.end=tween.start+tween.delay+tween.duration+tween.endDelay;tween.easing=parseEasings(tween.easing,tween.duration);tween.isPath=is.pth(tweenValue);tween.isColor=is.col(tween.from.original);if(tween.isColor){tween.round=1}previousTween=tween;return tween})}var setProgressValue={css:function(t,p,v){return t.style[p]=v},attribute:function(t,p,v){return t.setAttribute(p,v)},object:function(t,p,v){return t[p]=v},transform:function(t,p,v,transforms,manual){transforms.list.set(p,v);if(p===transforms.last||manual){var str="";transforms.list.forEach(function(value,prop){str+=prop+"("+value+") "});t.style.transform=str}}};function setTargetsValue(targets,properties){var animatables=getAnimatables(targets);animatables.forEach(function(animatable){for(var property in properties){var value=getFunctionValue(properties[property],animatable),target=animatable.target,valueUnit=getUnit(value),originalValue=getOriginalTargetValue(target,property,valueUnit,animatable),unit=valueUnit||getUnit(originalValue),to=getRelativeValue(validateValue(value,unit),originalValue),animType=getAnimationType(target,property);setProgressValue[animType](target,property,to,animatable.transforms,!0)}})}function createAnimation(animatable,prop){var animType=getAnimationType(animatable.target,prop.name);if(animType){var tweens=normalizeTweens(prop,animatable),lastTween=tweens[tweens.length-1];return{type:animType,property:prop.name,animatable:animatable,tweens:tweens,duration:lastTween.end,delay:tweens[0].delay,endDelay:lastTween.endDelay}}}function getAnimations(animatables,properties){return filterArray(flattenArray(animatables.map(function(animatable){return properties.map(function(prop){return createAnimation(animatable,prop)})})),function(a){return!is.und(a)})}function getInstanceTimings(animations,tweenSettings){var _Mathmax=Math.max,animLength=animations.length,getTlOffset=function(anim){return anim.timelineOffset?anim.timelineOffset:0},timings={};timings.duration=animLength?_Mathmax.apply(Math,animations.map(function(anim){return getTlOffset(anim)+anim.duration})):tweenSettings.duration;timings.delay=animLength?Math.min.apply(Math,animations.map(function(anim){return getTlOffset(anim)+anim.delay})):tweenSettings.delay;timings.endDelay=animLength?timings.duration-_Mathmax.apply(Math,animations.map(function(anim){return getTlOffset(anim)+anim.duration-anim.endDelay})):tweenSettings.endDelay;return timings}var instanceID=0;function createNewInstance(params){var instanceSettings=replaceObjectProps(defaultInstanceSettings,params),tweenSettings=replaceObjectProps(defaultTweenSettings,params),properties=getProperties(tweenSettings,params),animatables=getAnimatables(params.targets),animations=getAnimations(animatables,properties),timings=getInstanceTimings(animations,tweenSettings),id=instanceID;instanceID++;return mergeObjects(instanceSettings,{id:id,children:[],animatables:animatables,animations:animations,duration:timings.duration,delay:timings.delay,endDelay:timings.endDelay})}var activeInstances=[],pausedInstances=[],raf,engine=function(){function play(){raf=requestAnimationFrame(step)}function step(t){var activeInstancesLength=activeInstances.length;if(activeInstancesLength){var i=0;while(i<activeInstancesLength){var activeInstance=activeInstances[i];if(!activeInstance.paused){activeInstance.tick(t)}else{var instanceIndex=activeInstances.indexOf(activeInstance);if(-1<instanceIndex){activeInstances.splice(instanceIndex,1);activeInstancesLength=activeInstances.length}}i++}play()}else{raf=cancelAnimationFrame(raf)}}return play}();function handleVisibilityChange(){if(document.hidden){activeInstances.forEach(function(ins){return ins.pause()});pausedInstances=activeInstances.slice(0);activeInstances=[]}else{pausedInstances.forEach(function(ins){return ins.play()})}}if("undefined"!==typeof document){document.addEventListener("visibilitychange",handleVisibilityChange)}function anime(params){if(void 0===params)params={};var startTime=0,lastTime=0,now=0,children,childrenLength=0,resolve=null;function makePromise(instance){var promise=window.Promise&&new Promise(function(_resolve){return resolve=_resolve});instance.finished=promise;return promise}var instance=createNewInstance(params),promise=makePromise(instance);function toggleInstanceDirection(){var direction=instance.direction;if("alternate"!==direction){instance.direction="normal"!==direction?"normal":"reverse"}instance.reversed=!instance.reversed;children.forEach(function(child){return child.reversed=instance.reversed})}function adjustTime(time){return instance.reversed?instance.duration-time:time}function resetTime(){startTime=0;lastTime=adjustTime(instance.currentTime)*(1/anime.speed)}function seekCild(time,child){if(child){child.seek(time-child.timelineOffset)}}function syncInstanceChildren(time){if(!instance.reversePlayback){for(var i=0;i<childrenLength;i++){seekCild(time,children[i])}}else{for(var i$1=childrenLength;i$1--;){seekCild(time,children[i$1])}}}function setAnimationsProgress(insTime){var i=0,animations=instance.animations,animationsLength=animations.length;while(i<animationsLength){var anim=animations[i],animatable=anim.animatable,tweens=anim.tweens,tweenLength=tweens.length-1,tween=tweens[tweenLength];if(tweenLength){tween=filterArray(tweens,function(t){return insTime<t.end})[0]||tween}for(var elapsed=minMax(insTime-tween.start-tween.delay,0,tween.duration)/tween.duration,eased=isNaN(elapsed)?1:tween.easing(elapsed),strings=tween.to.strings,round=tween.round,numbers=[],toNumbersLength=tween.to.numbers.length,progress=void 0,n=0;n<toNumbersLength;n++){var value=void 0,toNumber=tween.to.numbers[n],fromNumber=tween.from.numbers[n]||0;if(!tween.isPath){value=fromNumber+eased*(toNumber-fromNumber)}else{value=getPathProgress(tween.value,eased*toNumber)}if(round){if(!(tween.isColor&&2<n)){value=Math.round(value*round)/round}}numbers.push(value)}var stringsLength=strings.length;if(!stringsLength){progress=numbers[0]}else{progress=strings[0];for(var s=0;s<stringsLength;s++){var a=strings[s],b=strings[s+1],n$1=numbers[s];if(!isNaN(n$1)){if(!b){progress+=n$1+" "}else{progress+=n$1+b}}}}setProgressValue[anim.type](animatable.target,anim.property,progress,animatable.transforms);anim.currentValue=progress;i++}}function setCallback(cb){if(instance[cb]&&!instance.passThrough){instance[cb](instance)}}function countIteration(){if(instance.remaining&&!0!==instance.remaining){instance.remaining--}}function setInstanceProgress(engineTime){var insDuration=instance.duration,insDelay=instance.delay,insEndDelay=insDuration-instance.endDelay,insTime=adjustTime(engineTime);instance.progress=minMax(100*(insTime/insDuration),0,100);instance.reversePlayback=insTime<instance.currentTime;if(children){syncInstanceChildren(insTime)}if(!instance.began&&0<instance.currentTime){instance.began=!0;setCallback("begin");setCallback("loopBegin")}if(insTime<=insDelay&&0!==instance.currentTime){setAnimationsProgress(0)}if(insTime>=insEndDelay&&instance.currentTime!==insDuration||!insDuration){setAnimationsProgress(insDuration)}if(insTime>insDelay&&insTime<insEndDelay){if(!instance.changeBegan){instance.changeBegan=!0;instance.changeCompleted=!1;setCallback("changeBegin")}setCallback("change");setAnimationsProgress(insTime)}else{if(instance.changeBegan){instance.changeCompleted=!0;instance.changeBegan=!1;setCallback("changeComplete")}}instance.currentTime=minMax(insTime,0,insDuration);if(instance.began){setCallback("update")}if(engineTime>=insDuration){lastTime=0;countIteration();if(instance.remaining){startTime=now;setCallback("loopComplete");setCallback("loopBegin");if("alternate"===instance.direction){toggleInstanceDirection()}}else{instance.paused=!0;if(!instance.completed){instance.completed=!0;setCallback("loopComplete");setCallback("complete");if(!instance.passThrough&&"Promise"in window){resolve();promise=makePromise(instance)}}}}}instance.reset=function(){var direction=instance.direction;instance.passThrough=!1;instance.currentTime=0;instance.progress=0;instance.paused=!0;instance.began=!1;instance.changeBegan=!1;instance.completed=!1;instance.changeCompleted=!1;instance.reversePlayback=!1;instance.reversed="reverse"===direction;instance.remaining=instance.loop;children=instance.children;childrenLength=children.length;for(var i=childrenLength;i--;){instance.children[i].reset()}if(instance.reversed&&!0!==instance.loop||"alternate"===direction&&1===instance.loop){instance.remaining++}setAnimationsProgress(0)};instance.set=function(targets,properties){setTargetsValue(targets,properties);return instance};instance.tick=function(t){now=t;if(!startTime){startTime=now}setInstanceProgress((now+(lastTime-startTime))*anime.speed)};instance.seek=function(time){setInstanceProgress(adjustTime(time))};instance.pause=function(){instance.paused=!0;resetTime()};instance.play=function(){if(!instance.paused){return}if(instance.completed){instance.reset()}instance.paused=!1;activeInstances.push(instance);resetTime();if(!raf){engine()}};instance.reverse=function(){toggleInstanceDirection();resetTime()};instance.restart=function(){instance.reset();instance.play()};instance.reset();if(instance.autoplay){instance.play()}return instance}function removeTargetsFromAnimations(targetsArray,animations){for(var a=animations.length;a--;){if(arrayContains(targetsArray,animations[a].animatable.target)){animations.splice(a,1)}}}function removeTargets(targets){for(var targetsArray=parseTargets(targets),i=activeInstances.length;i--;){var instance=activeInstances[i],animations=instance.animations,children=instance.children;removeTargetsFromAnimations(targetsArray,animations);for(var c=children.length;c--;){var child=children[c],childAnimations=child.animations;removeTargetsFromAnimations(targetsArray,childAnimations);if(!childAnimations.length&&!child.children.length){children.splice(c,1)}}if(!animations.length&&!children.length){instance.pause()}}}function stagger(val,params){var _Mathfloor=Math.floor,_Mathabs=Math.abs;if(void 0===params)params={};var direction=params.direction||"normal",easing=params.easing?parseEasings(params.easing):null,grid=params.grid,axis=params.axis,fromIndex=params.from||0,fromFirst="first"===fromIndex,fromCenter="center"===fromIndex,fromLast="last"===fromIndex,isRange=is.arr(val),val1=isRange?parseFloat(val[0]):parseFloat(val),val2=isRange?parseFloat(val[1]):0,unit=getUnit(isRange?val[1]:val)||0,start=params.start||0+(isRange?val1:0),values=[],maxValue=0;return function(el,i,t){if(fromFirst){fromIndex=0}if(fromCenter){fromIndex=(t-1)/2}if(fromLast){fromIndex=t-1}if(!values.length){for(var index=0;index<t;index++){if(!grid){values.push(_Mathabs(fromIndex-index))}else{var fromX=!fromCenter?fromIndex%grid[0]:(grid[0]-1)/2,fromY=!fromCenter?_Mathfloor(fromIndex/grid[0]):(grid[1]-1)/2,toX=index%grid[0],toY=_Mathfloor(index/grid[0]),distanceX=fromX-toX,distanceY=fromY-toY,value=Math.sqrt(distanceX*distanceX+distanceY*distanceY);if("x"===axis){value=-distanceX}if("y"===axis){value=-distanceY}values.push(value)}maxValue=Math.max.apply(Math,values)}if(easing){values=values.map(function(val){return easing(val/maxValue)*maxValue})}if("reverse"===direction){values=values.map(function(val){return axis?0>val?-1*val:-val:_Mathabs(maxValue-val)})}}var spacing=isRange?(val2-val1)/maxValue:val1;return start+spacing*(Math.round(100*values[i])/100)+unit}}function timeline(params){if(void 0===params)params={};var tl=anime(params);tl.duration=0;tl.add=function(instanceParams,timelineOffset){var tlIndex=activeInstances.indexOf(tl),children=tl.children;if(-1<tlIndex){activeInstances.splice(tlIndex,1)}function passThrough(ins){ins.passThrough=!0}for(var i=0;i<children.length;i++){passThrough(children[i])}var insParams=mergeObjects(instanceParams,replaceObjectProps(defaultTweenSettings,params));insParams.targets=insParams.targets||params.targets;var tlDuration=tl.duration;insParams.autoplay=!1;insParams.direction=tl.direction;insParams.timelineOffset=is.und(timelineOffset)?tlDuration:getRelativeValue(timelineOffset,tlDuration);passThrough(tl);tl.seek(insParams.timelineOffset);var ins=anime(insParams);passThrough(ins);children.push(ins);var timings=getInstanceTimings(children,params);tl.delay=timings.delay;tl.endDelay=timings.endDelay;tl.duration=timings.duration;tl.seek(0);tl.reset();if(tl.autoplay){tl.play()}return tl};return tl}anime.version="3.0.1";anime.speed=1;anime.running=activeInstances;anime.remove=removeTargets;anime.get=getOriginalTargetValue;anime.set=setTargetsValue;anime.convertPx=convertPxToUnit;anime.path=getPath;anime.setDashoffset=setDashoffset;anime.stagger=stagger;anime.timeline=timeline;anime.easing=parseEasings;anime.penner=penner;anime.random=function(min,max){return Math.floor(Math.random()*(max-min+1))+min};module.exports=anime;